/* cli qt clipboard, v. 0.01
   for the Midnight Commander
   Copyright (C) 2005 Vadim Likhota

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
 */


#include "qtclipb.h"
#include <qapplication.h>
#include <qtimer.h>
#include <qclipboard.h>
#include <qfile.h>
#include <qtextstream.h>


Qtclipb::Qtclipb( const char *text, QWidget *parent, const char *name )
    : QWidget(parent,name), t(text), b(-1)
{
    QTimer *timer = new QTimer(this);
    connect( timer, SIGNAL(timeout()), SLOT(inoutclip()) );
    timer->start( 128 ); // 64 yet not enough
}


void Qtclipb::inoutclip()
{
    if ( b < 0 ) {
	b++;
	int ins = 0, sel = 0, fl = 0;
	QString ar, s, fn; 
	QClipboard *cb = QApplication::clipboard();
        if ( qApp->argc() > 1 ) {
	    ar = qApp->argv()[1];
	    if ( ar.at(0) == '-' ) {
		for( unsigned int i = 1; i <= ar.length() ; i++  ) {
		    if ( ar.at(i) == 'i' )
			ins = 1;
		    if ( ar.at(i) == 's' )
			sel = 1;
		}
	    }
	    
	}
	if ( qApp->argc() > 2 ) {
	    if ( qApp->argv()[2][0] == '-' )
		fl = 1;
	    else 
		fn = qApp->argv()[2];
	}
	if ( ins ) {
	    if ( fl ) {
		QFile file;
		if ( file.open( IO_ReadOnly, stdin ) ) {
		    QString line;
		    QTextStream stream( &file );
		    stream.setEncoding( QTextStream::Locale );
		    s = "";
		    while ( !stream.atEnd() ) {
			line = stream.readLine();
			s += line + "\n";
		    }
		    file.close();
		}
		else
		    printf("Cannot read input. :(\n");
	    }
	    else {
		QFile file(fn);
		if ( file.open( IO_ReadOnly ) ) {
		    QString line;
		    QTextStream stream( &file );
		    stream.setEncoding( QTextStream::Locale );
		    s = "";
		    while ( !stream.atEnd() ) {
			line = stream.readLine();
			s += line + "\n";
		    }
		    file.close();
		}
		else 
		    printf("File not found :(\n");
	    }
	    if ( sel ) {
		cb->setText(s, QClipboard::Selection);
	    }
	    else {
		cb->setText(s, QClipboard::Clipboard);
	    }
	}
	else {
	    if ( sel ) {
		s = cb->text(QClipboard::Selection);
	    }
	    else {
		s = cb->text(QClipboard::Clipboard);
	    }
	    QFile file;
	    if ( file.open( IO_WriteOnly, stdout) ) {
		QTextStream stream( &file );
		stream.setEncoding( QTextStream::Locale );
		stream << s << "\n";
		file.close();
		QApplication::exit(0);
	    }
	    else
		printf("Cannot open stdout :(\n");
	}
	b++;
    }
    else
	if ( b > 0 )
	    QApplication::exit(0);
	else
	    printf("qtclipb: \"I get time to do it!\"\n");
}

